#ifndef __CMDTREE_H 
#define __CMDTREE_H V1.00

/********************************************************
**
**       Index to root_br
**
**    The index is based on alphabetical orderof the key 
**    word of all nodes in the help_br
********************************************************/

#define  CLEAR_IDX       0     /* CLEAR node */
#define  DEFINE_IDX      CLEAR_IDX+1  /* define node */
#define  ECHO_IDX	 DEFINE_IDX +1
#define  EXIT_IDX        ECHO_IDX+1
#define  HELP_IDX        EXIT_IDX+1  /* HELP node */
#define  HLS_IDX         HELP_IDX+1
#define  INI_IDX         HLS_IDX+1     /* INITIALIZE node */
/*
#define  LOAD_IDX        INI_IDX+1
*/
#define  LOGOUT_IDX      INI_IDX+1    /* logout node */
#define  MODIFY_IDX      LOGOUT_IDX+1
/* #define  PAKUTL_IDX      MODIFY_IDX+1 */
#define  PING_IDX        MODIFY_IDX+1   /* ping node */
#define  SAVE_IDX        PING_IDX+1
#define  SHOW_IDX        SAVE_IDX+1      /* show node */
#define  TESTER_IDX      SHOW_IDX +1  /* diagnosis node */
#define  END_OF_ROOT     TESTER_IDX+1


/*******************************************************
**
**      index to define_br[]
**
*******************************************************/
#define   DEF_BRG_IDX         0    		/* Define bridge node */
#define   DEF_DB_IDX          DEF_BRG_IDX+1 

/*** Vinay 5.5.93 ***************************
**************/
#define	 DEF_FDDI_IDX 	 	DEF_DB_IDX+1
#define  DEF_MOD_IDX		DEF_FDDI_IDX+1
/**********************************************************
#define   DEF_MOD_IDX         DEF_DB_IDX+1
**********************************************************/
#define   DEF_PORT_IDX        DEF_MOD_IDX+1 
#define   DEF_STP_IDX	      DEF_PORT_IDX+1

/*******************************************************
**
**	index to define_fddi_br[]
**
*******************************************************/
/**** Vinay 5.5.93
*******************************************************/
#define FDDI_MAC_IDX	0
#define FDDI_PATH_IDX	FDDI_MAC_IDX+1
#define FDDI_PORT_IDX	FDDI_PATH_IDX+1

/********************************************************
**
**	index to def_mod_smt[]
**
*********************************************************/
#define DEF_SMT_IDX	15

/*******************************************************
**
**      index to define_port_br[]
**
*******************************************************/
#define   DEF_PRT_BLK_IDX         0    		/* Define bridge node */
#define   DEF_PRT_LRN_IDX         DEF_PRT_BLK_IDX+1
#define   DEF_PRT_PAC_IDX         DEF_PRT_LRN_IDX+1
#define   DEF_PRT_PER_IDX         DEF_PRT_PAC_IDX+1

/******************************************************
**
**    index to show_prt_br[]
**
*******************************************************/
#define SHOW_PRT_FIL_IDX	0

/******************************************************
**
**    index to show_br[]
**
*******************************************************/
#define   SHOW_BRG_IDX        0
#define   SHOW_DB_IDX	      SHOW_BRG_IDX  +1	
/********* Vinay
***************************/
#define	  SHOW_FDDI_IDX		SHOW_DB_IDX + 1
/*****/
#define   SHOW_MOD_IDX        SHOW_FDDI_IDX   +1
#define   SHOW_PORT_IDX       SHOW_MOD_IDX  +1
#define   SHOW_STP_IDX        SHOW_PORT_IDX +1

/***************************************************
**
** index to clear_br[]
**
***************************************************/
#define CLR_BRG_IDX         0
#define CLR_DB_IDX          CLR_BRG_IDX+1
#define CLR_MOD_IDX         CLR_DB_IDX+1
#define CLR_PORT_IDX	    CLR_MOD_IDX+1


/*************************************************
**
**  Command name string representations
**
*************************************************/

/* THE ROOT BRANCH */
char SCLEAR[]  = "CLear";
char SDEFINE[] = "DEFine";
char SHLP[]    = "HElp";
char SHLS[]    = "HLS";       /* hidden command tree */
char SINIT[]   = "INItialize";
char SEXIT[]   = "EXit";
/************ Vinay 5.6.93
****/
char SECHO[]   = "ECho";
/************/
char SLOAD[]   = "LOAd";
char SLOGOUT[] = "LOgout";
char SMODIFY[] = "MODIfy";
char SPKTUTL[] = "PKTUTIL";
char SPASSWD[] = "PASsword";
char SPING[]   = "PIng";
char SSAVE[]   = "SAve";
char SSHOW[]   = "SHow";
char STESTER[] = "TEster";
char STFTP[]   = "TFtp";


/* THE SHOW BRANCH */
char SBRIDGE[]   = "BRidge";
char SDATABASE[] = "DATAbase";
char SMODULE[]   = "MODule";
char SPORTS[]    = "POrt";
char SSTP[]      = "STP";

/* THE SHOW BRIDGE BRANCH */
char SACTIVITY[] = "Activity";
char SBITMASK[]  = "BItmask";
char SIP[]       = "IP";
char SCONTACT[]  = "CONTact";
char SPARAM[] = "PArameters";
char SLOCATION[] = "LOCation";
char SLOG[]      = "LOG";
char SMSGLOG[]   = "Messagelog";
char SNAME[]     = "NAme";
char SRLOG[]     = "RLog";
char SSNMP[]     = "SNMP";
char SSNMPMGR[]  = "SNMPManager";
char SSTATUS[]   = "STATus";
char STRAFFIC[]  = "TRaffic";
char SUDPDIR[]   = "USPfilter";

/* THE SHOW DATABASE BRANCH */
char SDSAVED[]   = "SAved";
char SDSTATUS[]  = "STATus";
char SDWORK[]    = "WOrking";

/* THE SHOW PORT BRANCH */
char SPFILTER[]    = "FIltering";
char SPLEARN[]     = "LEarn";
char SPPACSIZE[]   = "PACketsize";
char SPSTATE[]     = "STATE";
char SPSTATUS[]    = "STATus";
char SPTHRESHOLD[] = "THreshold";

/* THE SHOW PORT FILTER BRANCH */
char SPFADDRESS[]  = "ADdress";
char SPFPROTOCOL[] = "PRotocol";
char SPFBITMASK[]  = "BItMask";

/* THE DEFINE BRANCH */
char DBRIDGE[]   = "BRidge";
char DDATABASE[] = "DATAbase";
char DMODULE[]   = "MODule";
char DPORTS[]    = "POrt";
char DSTP[]      = "STP";

/* THE CLEAR BRANCH */
char CBRIDGE[]   = "BRidge";
char CDATABASE[] = "DATAbase";
char CMODULE[]   = "MODule";
char CPORTS[]    = "POrt";
char CSMTCONNECTION[]  	 = "SMT";
char CCONNECTION[] = "CONNection";

/* THE CLEAR BRIDGE BRANCH */
char CBITMASK[]   = "BItMask";
char CCONTACT[]   = "CONTact";
char CIP[]        = "IP";
     char CADDR[] = "ADdress";
char CLOG[]       = "LOG";
char CLOCATION[]  = "LOCation";
char CNAME[]      = "NAme";
char CNETMASK[]   = "NEtMask";
char CRLOG[]      = "RLog";
char CTRAFFIC[]   = "TRaffic";
char CUDP[]       = "USPfilter";

/* THE CLEAR PORT BRANCH */
char CPROTOCOL[]  = "PRotocol";
char CBMEXPR[]    = "BMexpression";


/* THE DEFINE BRIDGE BRANCH */
char DAUTHENT[]   = "AUThentication";
char DBITMASK[]   = "BItmask";
char DBOOTPREQ[]  = "BOotp";
char DCFGFILE[]   = "CONFigfile";
char DCFG[]       = "CONFig";
     char DFILE[]      = "FIle";
char DCONTACT[]   = "CONTact";
char DDATE[]      = "DATE";
char DIP[]        = "IP";
     char DADDRESS[]   = "ADdress";
char DIPADDRESS[] = "IPAddress";
/* char DIPROUTER[]  = "IPRouter"; */
char DLOCATION[]  = "LOCation";
char DNAME[]      = "NAme";
char DNETMASK[]   = "NEtmask";
char DPASSWORD[]  = "PASsword";
char DPRIMARY[]   = "PRImary";
     char DROUTER[]   = "ROuter";
char DRQSTFILE[]  = "REquestfile";
char DRING[]	  = "RIng";
char DRQST[]      = "REQuest";
char DSECONDARY[] = "SECondary";
char DSNMPMGR[]   = "SNMPManager";
char DSTPMODE[]   = "STPMode";
char DSYMBOLIC[]  = "SYmbolic";
char DTFTP[]      = "TFtp";
char DSERVER[]    = "SERver";
char DTIME[]      = "TIME";
char DTIMEOUT[]   = "TIMEOut";
char DUDPFILTER[] = "USPfilter";
char DVT[]        = "VT100mode";

/* THE DEFINE PORT BRANCH */
char DBLOCK[]     = "BLock";
char DLEARN[]     = "LEarn";
char DEXTERNAL[]  = "EXternal";
    char DINTFC[] = "INterface";
char DPACSIZE[]   = "PACketsize";
char DPERMIT[]    = "PErmit";
char DRESTRICT[]  = "RESTrict";
char DPSTATE[]    = "STATE";
char DPTHRESHLD[] = "Threshold";
char DPUNKMCAST[] = "UNKMcast";
char DPUNKUCAST[] = "UNKUcast";

/* THE DEFINE PORT BLOCK BRANCH */
char DPPROTOCOL[] =  "PRotocol";
char DPBITMASK[]  =  "BMexpression";

/* THE DEFINE STP BRANCH */
char DSBRGPRI[]   = "BRidgepriority";
char DSDEFAULT[]  = "DEFAult";
char DSFORW[]     = "FOrwarddelay";
char DSHELLO[]    = "HEllotimer";
char DSLIFE[]     = "LIfetime";
char DSPATHCOST[] = "PAThcost";
char DSPORTPRI[]  = "PRIOrity";

/* THE SAVE DATABASE BRANCH */
char SDB[]        = "DATAbase";


/**** Vinay 5.5.93
********************/
/**************************************************************
	define_fddi_br
**************************************************************/
char DSINTERFACE[] 	= "INTerface";
char DSPORT[]		= "POrt";

/*************************************************************
	fddi_port_br
*************************************************************/
char DSACTION[]		= "ACTion";
char DSATTACHMENT[]	= "ATtachment";
char DSPOLICY[]		= "POLicy";
char DSCONNECTION[]	= "CONNection";
char DSPOLICIES[]	= "POlicies";
char DSTYPE[]		= "TYpe";
char DSLOCATION[]	= "LOCation";
char DSFDDIPORT[]	= "POrt";
char DSMACLOOP[]	= "MACloop";
char DSLERALARM[]	= "LERAlarm";
char DSLERCUTOFF[]	= "LERCutoff";
char DSMAINTLINESTATE[]	= "MAintlinestate";
char DSTB_MAX[]		= "TBMax";


/**************************************************************
	fddi_interface_br[]
**************************************************************/
char DSMAC[]		= "MAC";
char DSPATH[]		= "PAth";

/************************************************************
	fddi_mac_br[]
************************************************************/
char DSFRAMEERRTH[]	= "ERRor";
char DSFRAME[]		= "FRAme";
char DSFRAMESTATUS[]	= "STATus";
char DSNOTCOPIED[]	= "NOTCopied";
char DTHRESHOLD[]	= "THreshold";
char DSREQUESTED[]	= "REQuested";
char DSSTATE[]		= "STATE";
char DSSTRIPPING[]	= "STRipping";
char DST_MAX[]		= "TMAx";
char DST_MIN[]		= "TMIn";
char DST_PRI[]		= "TPRI";
char DST_REQ[]		= "TREQ";
char DSTVX[]		= "TVX";


/***************************************************************
	fddi_path_br[]
****************************************************************/
char DSTRACE_MAX[] 	= "TRAcemax";
char DSLOWER[]		= "Lower";
char DSLATENCY[]	= "LAtency";
char DSRING[]		= "RIng";
char DSRMODE[]		= "RMode";


char SFDDI[] = "FDdi";
char SSMT[] = "SMT";
char DSMT[] = "SMT";
char DSCONFIG[] = "CONFig";
char DSOPVERSION[] = "OPversion";
char SFDDIMAC[] = "MAC";
char SFDDIPATH[] = "PAth";
char SFDDIPORTS[] = "POrts";
char DSUSERDATA[] = "USerdata";
char DSREPORT[] = "REport";
char DSLIMIT[] = "LImit";
char DST_NOTIFY[] = "TNOtify";


/*************************************************************************/

/* THE HLS BRANCH OF HIDDEN COMMANDS */
char HDEBUG[]     = "Debug";
char HSHARP[]     = "Sarp";
char HSHMEM[]		= "Smem";
char HFLARP[]     = "Farp";
char HGOKRNL[]    = "Gokrnl";
char HHELP[]      = "Help";
char HPRTRFIC[]   = "Prtrfic";
char HPRTST[]     = "PrtSt";
char HVPROTS[]    = "VProts";
char HUPROTS[]    = "UProts";



#endif
