/*****************************************************************************
*       Program Name:  nim960 bridge
*
*       Filename:      mainglobal.c
*
*       $Log:   /b/gregs/bridge/declike/main/mainglobal.c_v  $
 * 
 *    Rev 1.1   03 Dec 1993 13:27:24   gregs
 * Moved adr_hshs to IRAM.
 * 
 *    Rev 1.0   04 May 1993 16:03:28   franks
 * Initial revision.
 * 
 *    Rev 1.2   04 May 1992 12:19:00   franks
 * No change.
 * 
 *    Rev 1.1   14 Apr 1992 13:09:12   franks
 * No change.
 * 
 *    Rev 1.0   30 Mar 1992 17:49:38   pvcs
 * Initial revision.
*
*       Comments:      Developed for i960 platform.
*                      DecLike Help Routines 	
*
*       (C) Copyright 1991 Hughes LAN Systems
*       
*	Listing of routines in this file:
*
*		
******************************************************************************/
#include <target.h>
#include <bridges.h>
#include <filter.h>
#include <nvrecs.h>
#include <krnl.h>
#include <stp.h>
#include <prcadr.h>
#include <prcctl.h>
#include <time.h>
#include <nim960h.h>
#include <sys.h>
#include <dips.h>
#include <log.h>

/* NEW INCLUDES FOR THE DECLIKE USER INTERFACE */
#include <ascii.h>
#include <param.h>
#include <834parser.h>
#include <cpb.h>

/* 834cmdmain.c */
/* GLOBAL VARIABLE DEFINITIONS  */

ERRORLOG         ErrorLogTable[MAXLOGTABLE];
uint             ErrorLogCount;
uint             ClearCounterTicks;
ADR              *adr_recs;
/* ADR              **adr_hshs;  -- Moved this pointer to IRAM */
NID              LocalAddress[NUMLADR];				
ADR              *NidSortAry;
ADR              *NvFilterTab;
NVR_BSTATUS      *BridgeStatus;
NVR_NID_RECS     *NvramNids;
NVR_RESETLOG     *RstLog;
unsigned char    *APPLSOFTVERSION;
struct tm        DateTime;
IP               IPDevice[10];
TIMER            IntervalTimer;
TIMER            InactivityTimer;
TIMER            SortTblTimer;
MBOX             TrRcvMBox;
unsigned long    InitTimeSeconds; /* Initial time in secs, from user */
unsigned long    InitDateSeconds; /* Initial time in secs, from user */
long GmtOffset = -(8*60*60);  /*  Offset from GMT based on geo location */
NID STPLAdr    = {0x8001, 0x00c2, 0x0000};	/* STP Group Address */
NID BCastAdr   = {0xffff, 0xffff, 0xffff};	/* Broadcast Address */


/* New Global definitions for the DecLike Parser */
RAM_PIT rampit;
CPB_T   cpb;

