/*****************************************************************************
*       Program Name:  nim960 bridge
*
*       Filename:      msg_tbl.c
*
*       $Log:   /b/gregs/bridge/declike/main/msg_tbl.c_v  $
 * 
 *    Rev 1.1   11 Jun 1993 12:06:18   vinay
 * added some error messages
 * 
 *    Rev 1.0   04 May 1993 16:03:28   franks
 * Initial revision.
 * 
 *    Rev 1.3   13 May 1992 14:57:14   franks
 * 1). 2 new error messages added.
 * 
 *    Rev 1.2   04 May 1992 12:21:30   franks
 * 1). New error message added for protocol type already defined.
 * 
 *    Rev 1.1   14 Apr 1992 13:12:40   franks
 * No change.
 * 
 *    Rev 1.0   30 Mar 1992 17:49:38   pvcs
 * Initial revision.
*
*       Comments:      Developed for i960 platform.
*                       	
*
*       (C) Copyright 1991 Hughes LAN Systems
*       
*	Listing of routines in this file:
*
*		
******************************************************************************/
/*******************************************************
**
**         msg_tbl
**
*******************************************************/

char *pOLD_PWD      = "\nEnter Old Password:";                 /* MSG_OLD_PWD */
char *pNEW_PWD      = "\nEnter New Password:";                 /* MSG_NEW_PWD */
char *pVER_PWD      = "\nEnter New Password Again To Verify:"; /* MSG_PWD_VER */
char *pPWD_CHG      = "Password has been changed\n";           /* MSG_PWD_CHG */
char *pLOGIN        = "\nLogin:";
char *pLOCK_PWD     = "\nLock Password:";
char *pUNLOCK_PWD   = "\nUnlock Password:";
char *pVER_LOCK_PWD = "Verify Unlock Password:";
char *pPASSWORD     = "Password:";
char *pUNKNOW       = "UNKNOWN";


char *errmsg[]={
   "Command syntax error",                    /* err code 1 - CMD_SYNTAX_ERR */
   "Keyword not known or ambiguous",          /* err code 2 - KW_UN_AMB      */
   "Value invalid or out of range,",          /* err code 3 - OUT_OF_RANGE   */
   "Login failed",                            /* err code 4 - LOGIN_FAIL     */
   "Invalid password",                        /* err code 5 - INVAL_PWD      */
   "Password verification fails",             /* err code 6 - PWD_VER_FAIL   */
   "Keyword is unknown",                      /* err code 7 - KW_UNKNOWN     */
   "Network address is invalid",              /* err code 8 - ERR_NET_ADDR   */
   "Network or host is unreachable ",         /* 9 - ERR_NET_UNREACHABLE     */
   "Command string too long",                 /* 10 - LINE_TOO_LONG          */
   "Not Implemented Yet...",
   "The IP address entered is invalid.",
   "The string entered is too long.\n",
   "The bit mask number entered is invalid( range is from 'A' to 'J').\n",
   "The bit mask offset value entered is invalid (range is from 0 to 256).\n",
   "The bit mask value must be an, 8 digit hex or 32 digit binary, number.\n",
   "The threshold value entered is invalid ( range is from 0 to 30000).\n",
   "Address not found.",
   "Address must be of the form 'XXXXXXXXXXXX' (hexadecimal).",
   "The definition is being used.",
   "The address already exists.",
   "User defined type field cannot be less than or equal to 1518 (0x05EE)\n",
   "User defined type does not exist.",
   "Keyword cannot be set.",
   "Address table is full.",
   "The bit mask expression is invalid.",
   "A port list must be entered for this command (range 1 to 4).\n",
   "The bitmask value has already been defined.",
   "The USER SPECIFIED protocol type already exists as a pre-defined type.\n",
   "ERR: This command only applies to port 4.",
   "ERR: There is no transceiver module installed.",
   "ERR: Cannot Modify.",
   "ERR: Connection policy does not exist",
   "Invalid Physical Address."
};
