
/*****************************************************************************
*       Program Name:  nim960 bridge
*
*       Filename:      834cmdmain.c
*
*       $Log:   /b/gregs/bridge/declike/term/834term.c_v  $
 * 
 *    Rev 1.0   04 May 1993 16:04:42   franks
 * Initial revision.
 * 
 *    Rev 1.0   30 Mar 1992 17:51:38   pvcs
 * Initial revision.
*
*       Comments:      Developed for i960 platform.
*                      834 VT100 Terminal control routines 
*
*       (C) Copyright 1991 Hughes LAN Systems
*       
*	Listing of routines in this file:
*
******************************************************************************/


TermClrScr() {
	/* Clear the screen */
	tty_out(0x1B); 					/* ESC */
	tty_out(0x5B); 					/* [   */
	tty_out(0x32); 					/* 2   */
	tty_out(0x4A); 					/* J   */	
}

TermHome()  {
	/* Position cursor to (1,1) */
	tty_out(0x1B); 					/* ESC        */
	tty_out(0x5B); 					/* [          */
	tty_out(0x31); 					/* 1 = row    */
	tty_out(0x3B); 					/* ;          */
	tty_out(0x31); 					/* 1 = column */
	tty_out(0x48); 					/* H          */
}

TermSeven()  {
	/* Position cursor to (1,7) */
	tty_out(0x1B); 					/* ESC        */
	tty_out(0x5B); 					/* [          */
	tty_out(0x37); 					/* 1 = row    */
	tty_out(0x3B); 					/* ;          */
	tty_out(0x31); 					/* 1 = column */
	tty_out(0x48); 					/* H          */
}

TermCrsOff()  {

	tty_out(0x1B); 					/* ESC        */
	tty_out(0x5B); 					/* [          */
	tty_out(0x3F);					/* ?          */
	tty_out(0x32);					/* 2          */
	tty_out(0x35);					/* 5          */
	tty_out(0x6C);					/* l          */
}

TermCrsOn()  {

	tty_out(0x1B); 					/* ESC        */
	tty_out(0x5B); 					/* [          */
	tty_out(0x3F);					/* ?          */
	tty_out(0x32);					/* 2          */
	tty_out(0x35);					/* 5          */
	tty_out(0x68);					/* h          */
}

TermCrsBlock()  {

	tty_out(0x1B); 					/* ESC        */
	tty_out(0x5B); 					/* [          */
	tty_out(0x33);	                                /* 0          */
	tty_out(0x76);                                  /* v          */
}

TermRevVid()  {

	tty_out(0x1B); 					/* ESC        */
	tty_out(0x5B); 					/* [          */
	tty_out(0x37);	                                /* 7          */
	tty_out(0x6D);                                  /* m          */
}

TermNormVid()  {

	tty_out(0x1B); 					/* ESC        */
	tty_out(0x5B); 					/* [          */
	tty_out(0x30);	                                /* 0          */
	tty_out(0x6D);                                  /* m          */
}

