/***********************************************************
 *
 *	Program Name:	nim960 multiport token ring bridge
 *
 *	Filename:
 *
 *	$Log:   /b/gregs/bridge/include/tr_sled.h_v  $
 * 
 *    Rev 1.5   26 Oct 1993 16:54:10   vinay
 * changed a to A, c to C and e to E for the seven seg LED display.
 * 
 *    Rev 1.4   12 Oct 1993 09:12:54   franks
 * No change.
 * 
 *    Rev 1.3   29 Sep 1993 09:35:38   franks
 * No change.
 * 
 *    Rev 1.2   10 Sep 1993 15:19:54   franks
 * No change.
 * 
 *    Rev 1.1   08 Sep 1993 11:04:22   franks
 * No change.
 * 
 *    Rev 1.0   07 Jul 1993 09:06:12   franks
 * Initial revision.
 *
 *	Creation Date:
 *
 *	Date:
 *
 *	Programmers:	Yan Ke
 *
 *	Modifications:
 *
 *	Comments:
 *
 *	Copyright (c) 1992 by Hughes LAN Systems
 *
 ************************************************************/

#ifndef	__TR_SLED_H
#define	__TR_SLED_H


/*************************************************
* Segment leds
**************************************************/

#define SLED_DOT		0x01

#define SLED_BAR_1		0x02
#define SLED_BAR_2		0x04
#define SLED_BAR_3		0x08
#define SLED_BAR_4		0x10
#define SLED_BAR_5		0x20
#define SLED_BAR_6		0x40
#define SLED_BAR_7		0x80

#define SLED_DIGIT_0		SLED_BAR_1
#define SLED_DIGIT_1		SLED_BAR_1 | SLED_BAR_2 | SLED_BAR_3 | SLED_BAR_4 | SLED_BAR_7
#define SLED_DIGIT_2		SLED_BAR_2 | SLED_BAR_5
#define SLED_DIGIT_3		SLED_BAR_2 | SLED_BAR_3
#define SLED_DIGIT_4		SLED_BAR_3 | SLED_BAR_4 | SLED_BAR_7
#define SLED_DIGIT_5		SLED_BAR_3 | SLED_BAR_6
#define SLED_DIGIT_6		SLED_BAR_6
#define SLED_DIGIT_7		SLED_BAR_1 | SLED_BAR_2 | SLED_BAR_3 | SLED_BAR_4
#define SLED_DIGIT_8		0
#define SLED_DIGIT_9		SLED_BAR_3
#define SLED_DIGIT_A		SLED_BAR_4
#define SLED_DIGIT_B		SLED_BAR_6 | SLED_BAR_7
#define SLED_DIGIT_C		SLED_BAR_5 | SLED_BAR_6 | SLED_BAR_1
#define SLED_DIGIT_D		SLED_BAR_2 | SLED_BAR_7
#define SLED_DIGIT_E		SLED_BAR_5 | SLED_BAR_6
#define SLED_DIGIT_F		SLED_BAR_4 | SLED_BAR_5 | SLED_BAR_6

#endif
