
/**
 *	Program Name:	nim960 bridge
 *
 *	Filename:	post.c
 *
 *	$Log:   /b/gregs/bridge/tester/post.c_v  $
 * 
 *    Rev 1.2   12 Oct 1993 09:22:48   franks
 * No change.
 * 
 *    Rev 1.1   29 Sep 1993 09:45:06   franks
 * No change.
 * 
 *    Rev 1.0   30 Jul 1993 13:25:52   franks
 * Initial revision.
 * 
 *    Rev 1.1   11 May 1992 12:08:24   kwok
 * Remove the function ErrorAbort() and create a new one in util/util.c.
 * 
 *    Rev 1.0   30 Mar 1992 17:42:26   pvcs
 * Initial revision.
 *
 *	Comments:
 *	
 *	Copyright (c) 1992 by Hughes LAN Systems
 **/

/*
 *	The Power on self test functions.
 */

#include <types.h>
#include <memory.h>
#include <eeprecs.h>
#include <nvram.h>
#include <led.h>

shram_test()
	{
	if (TestSharedRam() != 0)
		{
		ErrorAbort();
		}
	}
sram_test()
	{
	if (TestSram() != 0)
		{
		ErrorAbort();
		}
	}
dram_test()
	{
	if (TestDram() != 0)
		{
		ErrorAbort();
		}
	}
nvram_test()
	{
	if (TestNvram() != 0)
		{
		ErrorAbort();
		}
	}
eeprom_test()
	{
	if (TestEeprom() != 0)
		{
		ErrorAbort();
		}
	}
ethernet_test()
	{
	TestPort(0, 0);
	}
adminbus_test()
	{
	}

/******* K Kong 5.11.92. Moved to util/util.c

extern FlkLedInt();
extern usecInt();


ErrorAbort()
	{
	printf("\nProgram aborted\n");
	Di();
	init_timers(FlkLedInt, usecInt, 1, 100);
	Ei();
	set_leds(LED_BI, (LED_RDY | LED_ACT), (LED_RDY_RED | LED_ACT_RED));
	for (;;)
		{
		flk_led(LED_BI, LED_ACT);
		}
	}
*********/
