/*********************************************************************
	XLNT Manager(tm) MAP Header File

	Management Application Header File
	
	File:		maphdr.h
	Created:	02/26/91

	SID:		1.1
	Last Modified:	4/22/91
	
	Copyright 1990,1991 XLNT Designs, Inc.
	
	ALL RIGHTS RESERVED. THE SOURCE FILES DISTRIBUTED WITH THE
	XLNT Manager(tm) SYSTEM ARE THE SOLE PROPERTY OF XLNT Designs,
	Inc. AND CONTAIN CONFIDENTIAL AND PROPRIETARY INFORMATION.
	REPRODUCTION OR DUPLICATION BY ANY MEANS OF ANY PORTION OF
	THIS SOFTWARE WITHOUT PRIOR WRITTEN CONSENT OF XLNT Designs,
	Inc. IS EXPRESSLY FORBIDDEN.
	
	XLNT Manager is a trademark of XLNT Designs, Inc.

	* * * * *     N O T I C E     * * * * *

	XLNT Designs, Inc. (XDI) does not warrant that the functions
	contained in XLNT Manager(tm) will meet LICENSEE's requirements,
	or will operate in the combinations which may be selected for use
	by LICENSEE, or that the operation of XLNT Manager will be
	corrected after the warranty period. 
	ERRORS MAY EXIST IN XLNT Manager. DO NOT USE XLNT Manager 
	IN ANY CASE WHERE SIGNIFICANT DAMAGE OR INJURY TO 
	PERSONS, PROPERTY, OR BUSINESS MAY HAPPEN IF AN ERROR 
	OCCURS. LICENSEE EXPRESSLY ASSUMES ALL RISK FOR SUCH USE. 
	EXCEPT AS STATED IN THE LICENSING AGREEMENT, XDI MAKES NO
	WARRANTIES OF ANY KIND, EITHER EXPRESS OR IMPLIED,
	INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
	MERCHANTABILITY AND FITNESS FOR A PARTICULAR PUROSE,
	WITH RESPECT TO XLNT Manager. NO ORAL OR WRITTEN
	INFORMATION OR ADVICE GIVEN BY XDI, ITS DELAERS,
	DISTRIBUTORS, AGENTS, OR EMPLOYEES SHALL CREATE ANY OTHER
	WARRANTY OR IN ANY WAY INCREASE THE SCOPE OF THIS
	WARRANTY, AND LICENSEE MAY NOT RELY ON ANY SUCH
	INFORMATION OR ADVICE.

	This header file contains definitions for all application 
	dependent values.

	Modification History:
*********************************************************************/
#include "smtmacro.h"

/*********************************************************************
	Defined Values
*********************************************************************/

#define CHAR_RETURN     '\x0d'
#define CHAR_LINE_FEED  '\x0a'
#define	PROMPT		"\021\304\331"
#define	FRAME_LINES	11		/* # display lines in frame window */

#define	STATUS_WIN	0	/* general status window */
#define	INPUT_WIN	1	/* user input window */
#define	WORK_WIN	2	/* General active display window */
#define	FRAME_BUF_WIN	3	/* frame capture buffer window */
#define	FRAME_PARSE_WIN	4	/* parsed frame values window */
#define	DISPLAY_WIN	5	/* temporary display window */
#define	MENU_WIN	6	/* menu window */
#define	EVENT_WIN	7	/* event display */
#define	MAX_WIN_COUNT	8	/* number of displays */

#define	SMT_WIN		WORK_WIN
#define	MAC_STAT_WIN	WORK_WIN


/*********************************************************************
	Data Structures
*********************************************************************/

typedef	struct	itemStruct {
	char			name[26];
	char			selector;
	int			numItems;
	void			(*func)();
	struct itemStruct	*nextItem;
	struct itemStruct	*subItem;
} ItemType;

typedef	TLVParamType	MIBBufferType[15];

typedef	void	(*PTVF_t) ();

typedef struct window
{
   uChar wid;
   uChar row;
   uChar col;
} WINDOW;

