/**
 *	Program Name:	nim960 program
 *
 *	Filename:	ether.h	
 *
 *	$Log:   /shasta/pvcs/i960/include/mpd.h_v  $
 * 
 *    Rev 1.3   02 Apr 1993 09:30:46   holeman
 * fixes for gcc960 v 2.2
 * 
 *    Rev 1.2   18 Sep 1992 08:20:18   holeman
 * 
 *    Rev 1.1   31 Aug 1992 15:34:54   holeman
 * 
 *    Rev 1.0   28 Aug 1992 10:59:54   holeman
 * Initial revision.
 * 
 *    Rev 1.1   27 Aug 1992 15:45:56   holeman
 * 
 *    Rev 1.0   01 Jul 1992 14:27:02   holeman
 * Initial revision.
 *
 *	Comments:
 *
 *	Copyright (c) 1992 by Hughes LAN Systems
 **/
/*
Copyright (C) 1986 by FTP Software, Inc.

This software is furnished under a license and may be used and copied
only in accordance with the terms of such license and with the
inclusion of the above copyright notice. This software or any other
copies thereof may not be provided or otherwise made available to any
other person. No title to and ownership of the software is hereby
transferred.

The information in this software is subject to change without notice
and should not be construed as a commitment by FTP Software, Inc.
*/

/*  Copyright 1983, 1985 by the Massachusetts Institute of Technology  */
/*
 *	Kwok Kong	2.8.91
 *	replaced all unsigned, word, unsword with ushort for i960
 */

/* information common to all ethernet drivers
*/
#ifndef	__MPD_H
#define	__MPD_H

/* initialization modes: 0 = rcv normal + broadcast packets */
#define	LOOPBACK	0x01	/* send packets in loopback mode */
#define	ALLPACK		0x02	/* receive all packets: promiscuous */
#define	MULTI		0x04	/* receive multicast packets */

/*
* packet types: not all are used.
* Already byte swappeed
*/
#define	IP		0x0008	/* really 0x0800 */
#define	ARP		0x0608	/* really 0x0806 */
#define	CHAOS		0x0408	/* really 0x0804 */
#define	TRAILER0	0x0010	/* really 0x1000 */
#define	TRAILER1	0x0110	/* really 0x1001 */
#define	TRAILER2	0x0210	/* really 0x1002 */

/*
* snap header
*/
#pragma align 1
struct snap
	{
	byte	i_snp0;
	byte	i_snp1;
	byte	i_snp2;
	byte	i_dod0;
	byte	i_dod1;
	byte	i_dod2;
	byte	i_type0;
	byte	i_type1;
	};
#pragma align 0

/*
* special values for SNAP
*/
#define IEEESNP0  0xaa
#define IEEESNP1  0xaa
#define IEEESNP2  0x03
#define IEEEDOD0  0x00
#define IEEEDOD1  0x00
#define IEEEDOD2  0x00

/*
* minimum legal packet length
*/
#define	MINLEN	0

/*
* maximum length of packet header
*	token ring header	= 14
*	routing info		= 36	IBM (18) and ieee 802. ??
*	snap structure		=  8
*				 ----
*	total			  58
*/
#define MAXLNH 58

extern u_short BROADCAST[];

#endif
