/*
 * <string.h> : string handling routines for gcc960
 */

#ifndef __INC_H__
#define  __INC_H__

#undef memchr
#undef memcmp
#undef memcpy
#undef memmove
#undef memset
#undef strcat
#undef strchr
#undef strcmp
#undef strcpy
#undef strlen
#undef strncat
#undef strncmp
#undef strncpy
#undef strrchr
#undef strtol
#undef strtoul
#undef ntohl
#undef htonl
#undef htons
#undef ntohs

#if defined(__STDC__)
/*
 * Prototypes.
 */
void *		(memchr)(const void *, int, size_t);
int		(memcmp)(const void *, const void *, size_t);
void *		(memcpy)(void *, const void *, size_t);
void *		(memmove)(void *, const void *, size_t);
char *		(memset)(char *, int, size_t);
char *		(strcat)(char *, const char *);
char *		(strchr)(const char *, int);
int		(strcmp)(const char *, const char *);
char *		(strcpy)(char *, const char *);
size_t		(strcspn)(const char *, const char *);
size_t		(strlen)(const char *);
char *		(strncat)(char *, const char *, size_t);
int		(strncmp)(const char *, const char *, size_t);
char *		(strncpy)(char *, const char *, size_t);
char *		(strpbrk)(const char *, const char *);
char *		(strrchr)(const char *, int);
char *		(strrpbrk)(const char *, const char *);
int		(strrpos)(const char *, char);
size_t		(strspn)(const char *, const char *);
char *		(strstr)(const char *, const char *);
int		(strcoll)(const char *, const char *);
long 		(strtol)(const char *, char **, int);
unsigned long 	(strtoul)(const char *, char **, int);
long 		(ntohl)();
long 		(htonl)();
int 		(htons)();
int 		(ntohs)();

#else
/*
 * not STDC, just declare types.
 */
void *		(memchr)();
int		(memcmp)();
void *		(memcpy)();
void *		(memmove)();
void *		(memset)();
char *		(strcat)();
char *		(strchr)();
int		(strcmp)();
char *		(strcpy)();
size_t		(strcspn)();
size_t		(strlen)();
char *		(strncat)();
int		(strncmp)();
char *		(strncpy)();
char *		(strpbrk)();
char *		(strrchr)();
char *		(strrpbrk)();
int		(strrpos)();
size_t		(strspn)();
char *		(strstr)();
int		(strcoll)();
long 		(strtol)();
unsigned long 	(strtoul)();
long 		(ntohl)();
long 		(htonl)();
int 		(htons)();
int		(ntohs)();
#endif  /* __STDC__ */

#endif	/* __INC_H__ */

