/**			       
*
*	Program Name:	TESTER for stanley
*
*	Filename:	menuparse.h
*
*	$Log:   /b/gregs/i960/include/menuparse.h_v  $
 * 
 *    Rev 1.5   12 Oct 1993 09:43:52   franks
 * No change.
 * 
 *    Rev 1.4   29 Sep 1993 10:22:24   franks
 * No change.
 * 
 *    Rev 1.3   10 Sep 1993 15:22:32   franks
 * No change.
 * 
 *    Rev 1.2   08 Sep 1993 11:42:14   franks
 * No change.
 * 
 *    Rev 1.1   30 Jul 1993 13:38:14   franks
 * No change.
 * 
 *    Rev 1.0   14 Jul 1993 10:28:34   gregs
 * Initial revision.
 * 
 *    Rev 1.0   07 Apr 1992 16:29:44   pvcs
 * Initial revision.
*
*	Creation Date:	not known
*
*	Date:		7.8.91
*
*	Version:	1.0
*
*	Programmers:	K Kong
*
*	Modifications:
*
*	Comments:	This is a command line parsing for the eeprom editor,
*			memory editor and the KERNEL menu.
*			It is based on the nindy user interface.
*
*	Copyright (c) 1991 by Hughes LAN Systems
*
**/

/******************************************************************/
/* 		Copyright (c) 1989, Intel Corporation

   Intel hereby grants you permission to copy, modify, and 
   distribute this software and its documentation.  Intel grants
   this permission provided that the above copyright notice 
   appears in all copies and that both the copyright notice and
   this permission notice appear in supporting documentation.  In
   addition, Intel grants this permission provided that you
   prominently mark as not part of the original any modifications
   made to this software or documentation, and that the name of 
   Intel Corporation not be used in advertising or publicity 
   pertaining to distribution of the software or the documentation 
   without specific, written prior permission.  

   Intel Corporation does not warrant, guarantee or make any 
   representations regarding the use of, or the results of the use
   of, the software and documentation in terms of correctness, 
   accuracy, reliability, currentness, or otherwise; and you rely
   on the software, documentation and results solely at your own 
   risk.							  */

/************************************************************************
 * COMMAND TABLE
 *
 * The following table describes the keyboard commands.
 * The fields in each entry have the following meanings:
 *
 * cmd_name
 *	Name of command as a '\0'-terminated string.  Only the number of
 *	leading characters required for a match with user-entered input
 *	appear here,
 *
 * cmd_action
 *	Function that actually performs the command.  It should be
 *	invoked with the following arguments, in order:
 *		- the cmd_internal_arg from the command entry.
 *		- the number of following arguments that are valid on
 *			this call (some arguments may be optional).
 *		- one or more user-entered arguments, already parsed
 *			according to the corresponding cmd_argtypes.
 *
 * cmd_internal_arg
 *	First argument to be passed to the command action function.
 *
 * cmd_argtypes
 *	A '\0'-terminated list of characters describing the legal
 *	user-entered arguments to the command.  The ascii version
 *	of each argument should be translated into the corresponding
 *	type before it is passed to the action function.  Valid types are:
 *
 *	D  The text may be either a decimal constant (it should be
 *	   converted to binary before being passed) or a register name
 *	   (the register's contents should be passed).
 *
 *	H  The text may be either a hexadecimal constant (it should be
 *	   converted to binary before being passed) or a register name
 *	   (the register's contents should be passed).
 *
 *	S  The ASCII string should be passed unchanged to the action function.
 *
 *	Upper case letters indicate required arguments, lower case letters
 *	indicated optional arguments.  It is assumed that all required
 *	arguments always precede all optional ones.
 *
 ************************************************************************/
#include <defines.h>

struct cmd {
	char *cmd_name;
	int (*cmd_action)();
	long cmd_internal_arg;
	unsigned char cmd_argtypes[4];
};

int MenuParse(char *Greetings, const struct cmd *cmd_list);
int menuparse_help(const char *help_table[], int nargs, char *cmdname);
