

/**
*	Product Name:	all i960 based products
*
*	Program Name:	eebridge
*
*	Filename:	checksum.c
*
*	$Log:   /b/gregs/i960/libc/checksum.c_v  $
 * 
 *    Rev 1.5   12 Oct 1993 09:55:14   franks
 * No change.
 * 
 *    Rev 1.4   29 Sep 1993 10:23:54   franks
 * No change.
 * 
 *    Rev 1.3   10 Sep 1993 15:24:16   franks
 * No change.
 * 
 *    Rev 1.2   08 Sep 1993 11:31:04   franks
 * No change.
 * 
 *    Rev 1.1   30 Jul 1993 13:47:34   franks
 * No change.
 * 
 *    Rev 1.0   14 Jul 1993 10:23:10   gregs
 * Initial revision.
 * 
 *    Rev 1.0   30 Mar 1992 17:00:56   pvcs
 * Initial revision.
*
*	Creation Date:	3/30/92
*
*	Programmers:	gnu
*
*	Copyright (c) 1991 by Hughes LAN Systems
*
**/

/*
 *	Check sum calcuation for udp and ip
 *
 *	This is to replace the assembler version
 */
unsigned short cksum(unsigned short *buffer, int length)

	{
	unsigned long	sum = 0l;

	while (length--)
		{
		sum += *buffer++;
		/*
		 *	Add the carry bit in here as
		 *	length can be as long as 1 Meg or 
		 *	even more.
		 */
		sum = (sum & 0xFFFFl) + (sum >> 16);
		}
	/*
	 *	Add the remaining carry overflows
	 */
	while (sum >> 16)
		sum = (sum & 0xFFFFl) + (sum >> 16);
	return (unsigned short )sum;
	}
