

/**
*	Product Name:	all i960 based products
*
*	Program Name:	eebridge
*
*	Filename:	memset.c
*
*	$Log:   /b/gregs/i960/libc/memset.c_v  $
 * 
 *    Rev 1.5   12 Oct 1993 09:55:24   franks
 * No change.
 * 
 *    Rev 1.4   29 Sep 1993 10:24:04   franks
 * No change.
 * 
 *    Rev 1.3   10 Sep 1993 15:24:28   franks
 * No change.
 * 
 *    Rev 1.2   08 Sep 1993 11:31:20   franks
 * No change.
 * 
 *    Rev 1.1   30 Jul 1993 13:47:42   franks
 * No change.
 * 
 *    Rev 1.0   14 Jul 1993 10:23:16   gregs
 * Initial revision.
 * 
 *    Rev 1.0   30 Mar 1992 17:01:04   pvcs
 * Initial revision.
*
*	Creation Date:	3/30/92
*
*	Programmers:	gnu
*
*	Copyright (c) 1991 by Hughes LAN Systems
*
**/

#include "types.h"
#include "inc.h"

/*
 * memset() and bzero()
 *
 * [atw] written in a (moderately) efficient fashion using word
 * moves where possible.
 * If sufficiently motivated, could be rewritten for the 960 to
 * use long or quad-word instructions.
 */
#undef memset
#undef bzero

char *
memset(b, val, n)
char *b;
int val;
SIZET n;
{
    char *p;
    
    p = b;
    while(n--)
	*b++ = (char)val;

    return p;
}

void
bzero(ptr, len)
char *ptr;
int len;
{
  (void) memset(ptr, 0, len);
}
