/**			       
*
*	Program Name:	async module
*
*	Filename:	init.c
*
*	$Log:   /b/gregs/i960/tcpip/async/ainit.c_v  $
 * 
 *    Rev 1.2   12 Oct 1993 10:38:56   franks
 * No change.
 * 
 *    Rev 1.1   29 Sep 1993 10:27:30   franks
 * No change.
 * 
 *    Rev 1.0   14 Jul 1993 10:12:58   gregs
 * Initial revision.
 * 
 *    Rev 1.5   27 Jul 1992 17:57:32   forrest
 * Removed reference to V2
 * 
 *    Rev 1.4   17 Jun 1992 13:06:42   vinay
 * Removed the Errorlog function
 * 
 *    Rev 1.3   16 Jun 1992 14:41:18   vinay
 * Changed printf to include Errorlog function
 * 
 *    Rev 1.2   13 May 1992 09:53:20   pvcs
* 
*    	Rev 1.1   08 May 1992 14:06:08  
* 
*    	Rev 1.0   16 Apr 1992 18:19:12 
* 	Initial revision.
*
*	Creation Date:	not known
*
*	Date:		2.11.91
*
*	Version:	1.0
*
*	Programmers:	
*
*	Modifications:
*
*	Comments:	Port to i960 platform.
*
*	Copyright (c) 1991 by Hughes LAN Systems
*
**/

/*
 * Copyright (C) Sytek, Inc. 1987,8 
 */
#include <krnl.h>
#include <types.h>
#include <dbd.h>
#include <netbuf.h>
#include <ether.h>
#include <tcpip.h>
#include <error.h>

#define VERSION 0x11
tcpip *_initp;

/* FTP system init */
tcpip_init(initp)
register tcpip *initp;
	{
	int	x;

	/* adjust data from user */
	initp->numfree = initp->numtcps;

	/* Ramki (02/16/90) */
	/* Change the buffer size to 1518. This is necessary to get */
	/* LAT protocol working with PDP-11. */

	initp->rlenfree = RECEIVE_BUF_LEN;
	/* Make the transmit buffer size as 576 for lt3a and 1024 for SLIP */
	/* The receive and transmit buffer sizes are made different to free*/
	/* the dynamic memory. It is necessary to  receive frames of size */
	/* 1518 bytes but it is not necessary to transmit such big frames */
	/* We might have some performance degradation especially for LAT */
	/* Ramki(4/30/90)..... */
/*************************************
 *	K Kong 8.13.91
 *	tlenfree can be as big as receive buffer length as
 *	we have lots of memory.

#ifdef SLIP
	initp->tlenfree = TRANSMIT_BUF_LEN1;
#else
	initp->tlenfree = TRANSMIT_BUF_LEN;
#endif
************/	
	initp->tlenfree = RECEIVE_BUF_LEN;
	initp->version = VERSION;	/* version 1.0 */

	/* allocation calls */
	_initp = initp;
/*** FSFIX - Still need to do this, because it inits the tcp stack ***/
	if (x = premalloc(initp->numtcps, initp->numudps))
		return x;	     
/*****/
	initp->ifcntr = (IF_ENTRY  *)lmalloc(sizeof(IF_ENTRY) * initp->ifNumber);
	initp->ipcntr = (IP_STAT  *)lmalloc(sizeof(IP_STAT));
	initp->ipalrm = (IP_THRESHOLD  *)lmalloc(sizeof(IP_THRESHOLD));
	initp->ipstat = (IP_ENTRY  *)lmalloc(sizeof(IP_ENTRY));
	initp->tcpcntr= (TCP_STAT  *) lmalloc(sizeof(TCP_STAT));
	initp->tcpalrm= (TCP_THRESHOLD  *)lmalloc(sizeof(TCP_THRESHOLD));
	initp->tcpstat= (TCP_CON_ENTRY  *)lmalloc(sizeof(TCP_CON_ENTRY)
	              * initp->numtcps);

	if (initp->ifcntr == NULL || initp->ipcntr == NULL || 
		initp->ipstat == NULL || initp->tcpcntr == NULL || 
		initp->tcpalrm == NULL || initp->tcpstat == NULL || 
		initp->ipalrm == NULL) 
		{
		printf("Error: Not enough memory to allocate SNMP counters\n");
		return 1;
		}
	/* init calls */
	if (x = nim_init())
		return x;
	if (x = etainit())
		return x;
	if (x = in_init())
		return x;
	if (x = IcmpInit())
		return x;
	if (x = UdpInit())
		return x;
	if (x = RipInit())
		return x;
	if (x = tcp_init())
		return x;
	if (x = tn_init(initp->numtcps))
		return x;
	if (x = netio_init())
		return x;
	if (x = nmres_init())
		return x;
	/* load status into tcpip init struct */
	initp->inited = 1;	/* flag that we are done */
	return 0;
	}
